#ifndef DEFINES_H
#define DEFINES_H

#define ANGLES              360
#define ANGLEQUAD           (ANGLES/4)
#define BIN16               (1l<<16)
#define FINEANGLES          3600
#define MAP_WIDTH           16
#define MAP_HEIGHT          16
#define SCREEN_WIDTH        320
#define SCREEN_HEIGHT       200
#define SCREEN_CENTRE       100
#define GRID_SIZE           65536
#define MAP_TO_GRID_SHIFT   16l
#define MINDIST             0x5800l    /* in global coordinates */
#define FOCAL_LENGTH        0x5700l
#define FACE_DISTANCE       (FOCAL_LENGTH + MINDIST)
#define PROJECTION_RATIO    (((SCREEN_WIDTH / 2) * FACE_DISTANCE) / (GRID_SIZE /2)) 
#define PROJECTION_RATIO_SCALED    (GRID_SIZE * PROJECTION_RATIO)
#define MAP_WIDTH_SHIFT     4

/* 
================================================================
=
= Function: FixedMul
=
= Description:
=
= multiply two S32 numbers (and round result up)
= then store result back into a S32
=
================================================================
*/
static inline fixed FixedMul(fixed a, fixed b)
{
    return (fixed)(((long long)a * b + 0x8000) >> 16);
}

#endif
