#include <stdio.h>
#include <stdlib.h>
#include <SDL/SDL.h>
#include "types.h"
#include "defines.h"

/* defines */

/* None */

/* external variables */

/* None */

/* global variables */

U8 Map[MAP_HEIGHT][MAP_WIDTH] = {1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1,
                                 1, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 1,
                                 1, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 1,
                                 1, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 1,
                                 1, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 1,
                                 1, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 1,
                                 1, 0, 0, 0, 0, 0, 1, 2, 0, 2, 1, 0, 0, 0, 0, 1,
                                 1, 0, 0, 0, 0, 0, 1, 0, 0, 0, 1, 0, 0, 0, 0, 1,
                                 1, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 1,
                                 1, 0, 0, 0, 0, 0, 1, 0, 0, 0, 1, 0, 0, 0, 0, 1,
                                 1, 0, 0, 0, 0, 0, 1, 3, 0, 3, 1, 0, 0, 0, 0, 1,
                                 1, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 1,
                                 1, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 1,
                                 1, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 1,
                                 1, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 1,
                                 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1};


/* local variables */

/* None */

/* local prototypes */

/* None */

/* external prototypes */
extern void MovePlayer(input_type *Controls);
extern void Draw3D(void);
extern void GetUserInput(input_type *Controls);
extern U8 InitSDLScreenBuf(void);

/* 
================================================================
=
= Function: main (entry point)
=
= Description:
=
= Program to displays a simple 3d level using raycasting
=
================================================================
*/
int main(int argc, char *argv[])
{
    input_type UserControls;
    memset(&UserControls,0,sizeof(UserControls));

    /* try and get a handle to the screen */
    if(InitSDLScreenBuf() == 1)
    {
        /* cant get handle to screen so exit */
        return(1);
    }

    /* display simple 3d level until user decides to exit */
    while(UserControls.Exit == 0)
    {
        /* clear last user input */
        memset(&UserControls,0,sizeof(UserControls));
        /* then see if user was pressed a key */
        GetUserInput(&UserControls);
        /* move player if user pressed the arrow keys */
        MovePlayer(&UserControls);
        /* do raycasting of level*/
        Draw3D();
        /* wait so it consumes less processing time */
        SDL_Delay(10); 
    }
    
    /* bye bye */
    SDL_Quit();
}
